/*## (c) SECURITY EXPLORATIONS    2018 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import com.sun.net.httpserver.*;

public class HTTPServer {
 public static final String MULTIBOX_PATH = "/sw_upgrades/apollo/multibox";

 static class FileHandler implements HttpHandler {   
  public void not_found(HttpExchange t) throws IOException {
   String response="404 (Not Found)\n";

   t.sendResponseHeaders(404,response.length());
   OutputStream os=t.getResponseBody();
   os.write(response.getBytes());
   os.close();
  }

  public void handle_multibox(HttpExchange t) throws IOException {
   System.out.println("- sending multibox response");

   byte buf[]=Issue33.prepare_multiroom_auth_response();
   
   t.sendResponseHeaders(200,buf.length);
   OutputStream os=t.getResponseBody();
   os.write(buf,0,buf.length);
   os.close();
  }

  public void handle(HttpExchange t) throws IOException {
   URI uri=t.getRequestURI();
   String path=uri.getPath();
   String method=t.getRequestMethod();

   InetAddress host=t.getRemoteAddress().getAddress();

   System.out.println("["+host+"] "+method+" request for: "+path);

   if (path.equals(MULTIBOX_PATH)) {
    handle_multibox(t);
   } else not_found(t);
  }
 }

 public static void start(String host_addr,int port) {
  try {
   System.out.println("HTTP server listening on: "+port);

   HttpServer server=HttpServer.create(new InetSocketAddress(host_addr,port), 0);
   server.createContext("/",new FileHandler());
   server.setExecutor(null);
   server.start();
  } catch (Exception e) {
   e.printStackTrace();
  }
 }
}
